#include "stdafx.h"


CImeBox::CImeBox()
{
	Clear();
}

CImeBox::~CImeBox()
{
}

void CImeBox::Clear()
{
	m_length = 0;
	m_cursorX = 0;
	m_active = false;
	m_comLength = 0;
	m_candleNum = -1;
}

void CImeBox::AddChar(char c)		//  Ŀ ġ char ϳ ߰.
{
	if(m_length == MAX_LENGTH)
		return;

	int rightLen = 0;
	char rightStr[MAX_LENGTH];

	rightLen = GetRightString(rightStr);

	m_text[m_cursorX++] = c;
	m_length++;

	if(rightLen)
		strncpy(m_text + m_cursorX, rightStr ,rightLen);

	m_text[m_length] = 0;

}

void CImeBox::AddWord(char *w)		//  Ŀġ 2Ʈ ߰.
{
	if(m_length + 2 > MAX_LENGTH)
		return;

	char rightStr[MAX_LENGTH];
	int rightLen = GetRightString(rightStr);

	m_text[m_cursorX++] = *w;
	m_text[m_cursorX++] = *(w+1);
	m_length+= 2;

	if(rightLen)
		strncpy(m_text + m_cursorX, rightStr ,rightLen);

	m_text[m_length] = 0;
}

void CImeBox::AddString(char *string,int length)		// Ŀġ Ʈ߰.
{
	char *tmp = string;
	//   ϰ *- _-*.
	for(int i = 0;i<length;i++)
	{
		if(IsDBCSLeadByte(*tmp))
		{
			AddWord(tmp++);
			i++; tmp++;

		}
		else
		{
			AddChar(*tmp);
			tmp++;
		}
	}
}

void CImeBox::SetCandleText(const char *candles)
{
	strncpy(m_candleText,candles,MAX_CANDLE_LENGTH);
}

void CImeBox::SetCandleNum(int num)
{
	m_candleNum = num;
}

void CImeBox::SetCandleLength(int len)
{
	m_candleLength = len;
}

void CImeBox::Del()				// DELŰ.
{
	if(m_cursorX == m_length)
		return;

	char rightStr[MAX_LENGTH];
	int rightLen = GetRightString(rightStr);

	int check = 1;

	if(IsDBCSLeadByte(m_text[m_cursorX]))		// 2Ʈ.
	{
		m_length--;
		check += 1;
	}
	m_length--;

	m_text[m_cursorX] = 0;

	//		if(rightLen)
	strncpy(m_text + m_cursorX, rightStr + check,rightLen - check);

	m_text[m_length] = 0;
}

void CImeBox::Home()				// DELŰ.
{
	m_cursorX = 0;
}

void CImeBox::End()				// DELŰ.
{
	m_cursorX = m_length;
}

void CImeBox::BackSpace()		// ̽.
{
	if(m_cursorX == 0)
		return ;

	char rightStr[MAX_LENGTH];
	int rightLen = GetRightString(rightStr);

	if(IsDBCSLeadByte(m_text[--m_cursorX]))			// 2Ʈ.
	{
		--m_cursorX;
		--m_length;
	}
	--m_length;

	m_text[m_cursorX] = 0;


	if(rightLen)
		strncpy(m_text + m_cursorX, rightStr ,rightLen);

	m_text[m_length] = 0;
}

void CImeBox::Left()				// .
{
	if(m_cursorX == 0)
		return;

	if(IsDBCSLeadByte(m_text[--m_cursorX]))
	{
		--m_cursorX;
	}
}

void CImeBox::Right()			// .
{
	if(m_cursorX == m_length)
		return;

	if(IsDBCSLeadByte(m_text[m_cursorX++]))
	{
		m_cursorX++;
	}
}

void CImeBox::CandleLeft()
{
	if(!IsCandle())
		return;

	if(m_candleNum == 0)
		return;

	m_candleNum -= 9;
}

void CImeBox::CandleRight()
{
	if(!IsCandle())
		return;

	if(m_candleNum + 9 >= m_candleLength)
		return;

	m_candleNum += 9;
}


// character.. process.
int CImeBox::GetLeftString(char *target)			// Ŀ ߽  ڵ ´
{
	if(m_cursorX == 0)
		return 0;

	strncpy(target, m_text, m_cursorX);
	return m_cursorX;
}

int CImeBox::GetRightString(char *target)		// Ŀ ߽  ڵ ´.
{
	if(m_cursorX == m_length)
		return 0;

	strncpy(target,m_text + m_cursorX, m_length - m_cursorX);

	return m_length - m_cursorX;
}


// set..
void CImeBox::SetComText(char *text,int length){
	strncpy(m_comText,text, length);
	m_comText[length] = 0;
	m_comLength = length;
}

void CImeBox::SetComTextBlank()
{
	m_comText[0] = 0; 
	m_comLength = 0;
}

// get..
int	CImeBox::GetMaxLength()
{
	return MAX_LENGTH;
}

char* CImeBox::GetText()
{ 
	return m_text;
}

char* CImeBox::GetComText()
{
	return m_comText;
}

int	CImeBox::GetComTextlength()	
{ 
	return m_comLength;
}

char* CImeBox::GetCandle()
{
	static char tmp[18 + 1];
	strncpy(tmp, m_candleText + (m_candleNum << 1),18);
	tmp[18] = 0;

	return tmp;
}

char* CImeBox::GetCandleText()
{
	return m_candleText;
}

int	CImeBox::GetCandleTextlength()
{
	return m_candleLength;
}

int	CImeBox::GetLength()	
{
	return m_length;
}

int	 CImeBox::GetCursorX()
{
	return m_cursorX;
}

bool CImeBox::GetAvtive()	
{
	return m_active;
}

bool CImeBox::IsCandle()
{
	if(m_candleNum == -1)
		return false;

	return true;
}
