#include "stdafx.h"


CImeBase * CImeBase::ms_pThis;

CImeBase & CImeBase::Instance()
{
	assert(ms_pThis!=NULL && "CImeBase - EMPTY Instance");
	return *ms_pThis;
}

static CImeBase & Instance()
{

}

CImeBase::CImeBase()
{
	ms_pThis=this;			// ڽ  : )
	Clear();
}

CImeBase::~CImeBase()
{
}

CImeBox* CImeBase::GetImeBox()
{
	return m_imeBox;
}

bool CImeBase::GetComposition(HWND hWnd, WPARAM wparam, LPARAM lparam)
{
	assert(m_imeBox != NULL && "bool CImeBase::GetComposition()    m_imeBox is NULL.");

	HIMC	m_hIMC = ImmGetContext(hWnd);


	if(lparam & GCS_RESULTSTR){		//   ~ - _-)d
		char szTmp[21];		// ӽ. ׷  Ѳ 20 Ѿ´ٰغ? = _=)a

		int len = ImmGetCompositionString(m_hIMC, GCS_RESULTSTR, NULL, 0);

		if(len == 0) return false;

		ImmGetCompositionString(m_hIMC, GCS_RESULTSTR, szTmp, len);

		m_imeBox->AddString(szTmp,len);

		m_imeBox->SetComText("",0);		//  ڿ ۸ ش.
	}
	else if(lparam & GCS_COMPSTR)
	{
		char szTmp[21];

		int len = ImmGetCompositionString(m_hIMC, GCS_COMPSTR, NULL, 0);
		
		if(len + m_imeBox->GetLength() > m_imeBox->GetMaxLength())	// ִ̺ .
		{
			ImmNotifyIME(m_hIMC, NI_COMPOSITIONSTR, CPS_CANCEL, 0);		//  ڿ .

			m_imeBox->SetComText("",0);
			return true;
		}

		ImmGetCompositionString(m_hIMC, GCS_COMPSTR, szTmp, len);

		m_imeBox->SetComText(szTmp, len);
	}
	ImmReleaseContext(hWnd, m_hIMC);

	return true;
}


bool CImeBase::GetMsg(HWND hWnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	if(m_imeBox == NULL)
		return false;

	switch(msg)
	{
		case WM_CHAR:						//  Ѿ
			return GetChar(wparam,lparam);

		case WM_KEYDOWN:					//  Ű .
			return GetKey(wparam,lparam);

		case WM_IME_NOTIFY:
			return GetCandle(hWnd,wparam,lparam);

		case WM_IME_COMPOSITION:			//  .
			return GetComposition(hWnd,wparam, lparam);

	}
	return false;
}

bool CImeBase::GetKey(WPARAM wparam, LPARAM lparam)
{
	switch (wparam){
		case VK_LEFT:
			m_imeBox->Left();
			return true;

		case VK_RIGHT:
			m_imeBox->Right();
			return true;

		case VK_DELETE:
			m_imeBox->Del();
			return true;

		case VK_HOME:
			m_imeBox->Home();
			return true;

		case VK_END:
			m_imeBox->End();
			return true;

		case VK_PROCESSKEY:
			if(lparam == 0x14B0001) //  = _=) ӳ̳밡ٴ..;;
			{
				m_imeBox->CandleLeft();
			}
			else if(lparam == 0x14D0001) // .
			{
				m_imeBox->CandleRight();
			}
			
			return true;


//		case VK_RETURN:   imeڽ ؼ Ű  
//			޼ ڽ ִ.. 
//          m_imeBoxκ ˾Ƽ ó on_return  ӹ޾Ƽ ô
//			˾Ƽ غ..; - -)a

	}

	return false;
}

bool CImeBase::GetCandle(HWND hWnd, WPARAM wparam, LPARAM lparam)
{
	HIMC m_hIMC = ImmGetContext(hWnd);

	DWORD dwBufLen;

	LPCANDIDATELIST m_CandList;
	LPCANDIDATELIST lpCandList;

	char CanText[256];
	int	 CanNum;


	switch (wparam) {
		case IMN_OPENCANDIDATE:   // first

			if((dwBufLen = ImmGetCandidateList(m_hIMC, 0, NULL, 0)) == 0) break;
																// ˵ Ʈ ̸ ´.

			m_CandList = (LPCANDIDATELIST)new char[dwBufLen];	// ̸ŭ Ҵ.
			lpCandList = m_CandList;

			ImmGetCandidateList(m_hIMC, 0, lpCandList, dwBufLen);	// Ʈ ּҸ ´.

			CanNum = lpCandList->dwCount;							// ټ

			CanText[0] = 0;		//  ڸ ʱȭ.

			for(int i=0;i<CanNum;i++){								// ϳ -//-.
				strcat(CanText, (LPSTR)lpCandList + lpCandList->dwOffset[i]);
			}

			m_imeBox->SetCandleNum(0);
			m_imeBox->SetCandleText(CanText);
			m_imeBox->SetCandleLength(CanNum);
			delete m_CandList;

			break;

		case IMN_CHANGECANDIDATE:
			break;

		case IMN_CLOSECANDIDATE:
			m_imeBox->SetCandleLength(0);
			m_imeBox->SetCandleNum(-1);
			break;
	}
	ImmReleaseContext(hWnd, m_hIMC);

	return true;
}

bool CImeBase::GetChar(WPARAM wparam, LPARAM lparam)
{
	assert(m_imeBox != NULL && "bool CImeBase::GetChar()    m_imeBox is NULL.");

	switch (wparam){
		case VK_BACK:		// 齺̽.
			m_imeBox->BackSpace();
			return true;

		default:
			if(IsDBCSLeadByte((BYTE)wparam))		// ѱ̸ ϴ . (ѱ ٸ ޴´.)
				return true;

			m_imeBox->AddChar((BYTE)wparam);		// - _-)d

			return true;
	}
	return false;
}


void CImeBase::SetFocus(CImeBox &ime_box)		// NULL  = _=)  ǰ.
{
	m_imeBox = &ime_box;
}


void CImeBase::Clear()
{
	m_imeBox = NULL;
}
